VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" _
(ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String _
, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long _
, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long _
, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const WM_USER = &H400
Private Const WS_CHILD = &H40000000
Private Const WS_VISIBLE = &H10000000
'    
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
'    
Private Const PB_CLASS_NAME = "msctls_progress32"
'  -  
Private Const PBM_SETPOS = WM_USER + 2
'  -  
Private Const PBM_SETRANGE = WM_USER + 1
'  -    
Private Const PBM_DELTAPOS = WM_USER + 3
'  -   
Private Const PBM_SETSTEP = WM_USER + 4
'  -  
Private Const PBM_STEPIT = WM_USER + 5

'  
Private hProgress As Long
'  
Private lValue As Long
'  
Private lMax As Long
'  
Private lMin As Long
'  
Private lTop As Long
Private lLeft As Long
Private lWidth As Long
Private lHeight As Long
'   
Private lDeltaPos As Long

'    ,    .
'      ,      100.
Private Sub Class_Initialize()
    InitCommonControls
    lMax = 100
End Sub

'    ,   .
Private Sub Class_Terminate()
    If hProgress <> 0 Then DestroyWindow hProgress
End Sub

'     Create, ,     CreateWindowEx.
'        - ,     .
Public Sub Create(ByVal hWndParent As Long, _
    ByVal Left As Long, ByVal Top As Long, _
    ByVal Width As Long, ByVal Height As Long)
   '        .
    hProgress = CreateWindowEx(0, PB_CLASS_NAME, "PB", _
    WS_CHILD Or WS_VISIBLE, Left, Top, Width, Height, _
    hWndParent, 0, App.hInstance, ByVal 0&)
    '    
    lTop = Top
    lLeft = Left
    lWidth = Width
    lHeight = Height
End Sub

'   ,   .        Resize  SetRange.
'         .   .
Private Sub Resize()
    '  SetWindowPos,   ,  
    '  ZOrder   SWP_NOZORDER.
    '   
    If hProgress <> 0 Then SetWindowPos hProgress, 0, lLeft, lTop, lWidth, lHeight, SWP_NOZORDER
End Sub

Private Sub SetRange()
    On Error Resume Next
    Dim R As Long
    '      SendMessage
    '     lMin  lMax.
    ' lMin    ,  lMax  .
    R = CLng((lMin And &HFFFF&) Or ((lMax And &HFFFF&) * 65536))
    If hProgress <> 0 Then SendMessage hProgress, PBM_SETRANGE, 0, ByVal R
End Sub

'    Move.     ,   .
Public Sub Move(Optional Left As Long, Optional Top As Long, _
    Optional Width As Long, Optional Height As Long)
    '       .
    If Not IsMissing(Top) Then lTop = Top
    If Not IsMissing(Left) Then lLeft = Left
    If Not IsMissing(Width) Then lWidth = Width
    If Not IsMissing(Height) Then lHeight = Height
    Resize
End Sub

'     ,     .
Public Property Let Left(ByVal NewLeft As Long)
    lLeft = NewLeft
    Resize
End Property
Public Property Get Left() As Long
    Left = lLeft
End Property

Public Property Let Top(ByVal NewTop As Long)
    lTop = NewTop
    Resize
End Property
Public Property Get Top() As Long
    Top = lTop
End Property

Public Property Let Width(ByVal NewWidth As Long)
    lWidth = NewWidth
    Resize
End Property
Public Property Get Width() As Long
    Width = lWidth
End Property

Public Property Let Height(ByVal NewHeight As Long)
    lHeight = NewHeight
    Resize
End Property
Public Property Get Height() As Long
    Height = lHeight
End Property


Public Property Let Min(ByVal NewMin As Long)
    lMin = NewMin
    SetRange
End Property
Public Property Get Min() As Long
    Min = lMin
End Property

Public Property Let Max(ByVal NewMax As Long)
    lMax = NewMax
    SetRange
End Property
Public Property Get Max() As Long
    Max = lMax
End Property


Public Property Let Value(ByVal NewValue As Long)
    lValue = NewValue
    If hProgress <> 0 Then SendMessage hProgress, PBM_SETPOS, lValue, ByVal 0&
End Property
Public Property Get Value() As Long
    Value = lValue
End Property


Public Property Let DeltaPos(ByVal NewDeltaPos As Long)
    lDeltaPos = NewDeltaPos
    If hProgress <> 0 Then SendMessage hProgress, PBM_SETPOS, lDeltaPos, ByVal 0&
End Property
Public Property Get DeltaPos() As Long
    DeltaPos = lDeltaPos
End Property


Public Property Get hwnd() As Long
    hwnd = hProgress
End Property
